# ISR-of-Purkinje-cells

This is the README for the model associated with the paper:

Buchin A, Rieubland S, Häusser M, Gutkin BS, Roth A (2016)
Inverse Stochastic Resonance in Cerebellar Purkinje Cells.
PLoS Comput Biol 12:e1005000

This code was contributed by A Buchin.

The code shows the simulations of the adaptive exponential
integrate-and-fire model
(http://www.scholarpedia.org/article/Adaptive_exponential_integrate-and-fire_model)
at different stimulus conditions. The parameters of the model were
tuned to the Purkinje cell of cerebellum to reproduce the inhibiion of
these cells by noisy current injections. Similar experimental
protocols were also applied to the detailed biophysical model of
Purkinje cells, Bower-de-Shutter model
(http://jn.physiology.org/content/71/1/375.short). The repository also
includes the XPPaut version of the model with the corresponding
bifurcation analysis.

If you would like to use this code for the scientific publication,
please do not forget to cite the original paper
http://journals.plos.org/ploscompbiol/article?id=10.1371/journal.pcbi.1005000

If you have any troubles with running these simulations, do not
hesitate to let me know.

Best
Anatoly
